<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eicd: eicd/MCParticleCollection.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eicd
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e4e37cb967a0a8dac9982f75962b5bf7.html">eicd</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">MCParticleCollection.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_m_c_particle_collection_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// AUTOMATICALLY GENERATED FILE - DO NOT EDIT</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef EICD_MCParticleCollection_H</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define EICD_MCParticleCollection_H</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// datamodel specific includes</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_m_c_particle_data_8h.html">eicd/MCParticleData.h</a>&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_m_c_particle_8h.html">eicd/MCParticle.h</a>&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_m_c_particle_obj_8h.html">eicd/MCParticleObj.h</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// podio specific includes</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;podio/ICollectionProvider.h&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;podio/CollectionBase.h&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;podio/CollectionIDTable.h&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;deque&gt;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;array&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;ostream&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceeic.html">eic</a> {</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="namespaceeic.html#a5bd8e90bfeab64c62afd20fef747150d">   26</a></span>&#160;<span class="keyword">using</span> <a class="code" href="namespaceeic.html#a5bd8e90bfeab64c62afd20fef747150d">MCParticleDataContainer</a> = std::vector&lt;MCParticleData&gt;;</div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="namespaceeic.html#a3b60abb8ab87a16a3de493b946494cd8">   27</a></span>&#160;<span class="keyword">using</span> <a class="code" href="namespaceeic.html#a3b60abb8ab87a16a3de493b946494cd8">MCParticleObjPointerContainer</a> = std::deque&lt;MCParticleObj*&gt;;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection_iterator.html">   29</a></span>&#160;<span class="keyword">class </span><a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html">MCParticleCollectionIterator</a> {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection_iterator.html#a58727d055ea313cbc311aa13cbca828b">   31</a></span>&#160;  <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html#a58727d055ea313cbc311aa13cbca828b">MCParticleCollectionIterator</a>(<span class="keywordtype">int</span> index, <span class="keyword">const</span> <a class="code" href="namespaceeic.html#a3b60abb8ab87a16a3de493b946494cd8">MCParticleObjPointerContainer</a>* collection) : m_index(index), m_object(nullptr), m_collection(collection) {}</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection_iterator.html#a208df947157c71dfcd9700c6cd244d2b">   33</a></span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html#a208df947157c71dfcd9700c6cd244d2b">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html">MCParticleCollectionIterator</a>&amp; x)<span class="keyword"> const </span>{</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordflow">return</span> m_index != x.m_index; <span class="comment">// TODO: may not be complete</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;  }</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;  <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html#a18cfe3aa4eff0cc87907c9c6143770c9">operator*</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;  <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a>* <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html#af6248ebaba9075fcf9752608c95a9bff">operator-&gt;</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;  <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html">MCParticleCollectionIterator</a>&amp; <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html#a135e791096be03f92c8ae6caaea014e5">operator++</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;  <span class="keyword">mutable</span> <span class="keywordtype">int</span> m_index;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;  <span class="keyword">mutable</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> m_object;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="keyword">const</span> <a class="code" href="namespaceeic.html#a3b60abb8ab87a16a3de493b946494cd8">MCParticleObjPointerContainer</a>* m_collection;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;};</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html">   50</a></span>&#160;<span class="keyword">class </span><a class="code" href="classeic_1_1_m_c_particle_collection.html">MCParticleCollection</a> : <span class="keyword">public</span> podio::CollectionBase {</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#ad754e1fd69ad26674dc1a26fa8d376d4">   53</a></span>&#160;  <span class="keyword">using</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html">const_iterator</a> = <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html#a58727d055ea313cbc311aa13cbca828b">MCParticleCollectionIterator</a>;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  <a class="code" href="classeic_1_1_m_c_particle_collection.html">MCParticleCollection</a>();</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment">//  MCParticleCollection(const MCParticleCollection&amp; ) = delete; // deletion doesn&#39;t work w/ ROOT IO ! :-(</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment">//  MCParticleCollection(MCParticleVector* data, int collectionID);</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;  ~<a class="code" href="classeic_1_1_m_c_particle_collection.html">MCParticleCollection</a>();</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;  <span class="keywordtype">void</span> clear() override final;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#ae1078fb78f81595469b0baf352f111c6">   63</a></span>&#160;  <a class="code" href="classeic_1_1_m_c_particle_collection.html">MCParticleCollection</a>* operator-&gt;() { <span class="keywordflow">return</span> (<a class="code" href="classeic_1_1_m_c_particle_collection.html">MCParticleCollection</a>*) <span class="keyword">this</span>; }</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;  <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> create();</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="keyword">template</span>&lt;<span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> create(Args&amp;&amp;... args);</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  <span class="keywordtype">size_t</span> size() <span class="keyword">const</span> <span class="keyword">override</span> <span class="keyword">final</span>;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a83bdd7d2e8c22831ecf5352434fe01cc">   77</a></span>&#160;  std::string <a class="code" href="classeic_1_1_m_c_particle_collection.html#a83bdd7d2e8c22831ecf5352434fe01cc">getValueTypeName</a>()<span class="keyword"> const override </span>{ <span class="keywordflow">return</span> std::string(<span class="stringliteral">&quot;eic::MCParticle&quot;</span>); }</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;  <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> operator[](<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) <span class="keyword">const</span>;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;  <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> operator[](<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;  <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> at(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) <span class="keyword">const</span>;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;  <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> at(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="keywordtype">void</span> push_back(<a class="code" href="classeic_1_1_const_m_c_particle.html">ConstMCParticle</a> <span class="keywordtype">object</span>);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;  <span class="keywordtype">void</span> prepareForWrite() <span class="keyword">override</span> <span class="keyword">final</span>;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;  <span class="keywordtype">void</span> prepareAfterRead() <span class="keyword">override</span> <span class="keyword">final</span>;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;  <span class="keywordtype">void</span> setBuffer(<span class="keywordtype">void</span>* address) <span class="keyword">override</span> <span class="keyword">final</span>;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;  <span class="keywordtype">bool</span> setReferences(<span class="keyword">const</span> podio::ICollectionProvider* collectionProvider) <span class="keyword">override</span> <span class="keyword">final</span>;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a01fb59231ec11d4832bf89c1b7fa0244">   97</a></span>&#160;  podio::CollRefCollection* <a class="code" href="classeic_1_1_m_c_particle_collection.html#a01fb59231ec11d4832bf89c1b7fa0244">referenceCollections</a>() override final { <span class="keywordflow">return</span> &amp;m_refCollections; }</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a04a4b9fb0e399346bf332f113db46235">   99</a></span>&#160;  podio::VectorMembersInfo* <a class="code" href="classeic_1_1_m_c_particle_collection.html#a04a4b9fb0e399346bf332f113db46235">vectorMembers</a>()<span class="keyword"> override </span>{ <span class="keywordflow">return</span> &amp;m_vecmem_info; }</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#af7ed58e80878af7e156475631220748b">  101</a></span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#af7ed58e80878af7e156475631220748b">setID</a>(<span class="keywordtype">unsigned</span> ID) <span class="keyword">override</span> <span class="keyword">final</span> {</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    m_collectionID = ID;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    std::for_each(m_entries.begin(),m_entries.end(),</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                  [ID] (<a class="code" href="classeic_1_1_m_c_particle_obj.html">MCParticleObj</a>* obj) { obj-&gt;id = {obj-&gt;id.index, <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(ID)}; }</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    );</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;  };</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#ac55b0b9d1f7a0697bdc1de8a0e6c0f35">  108</a></span>&#160;  <span class="keywordtype">unsigned</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#ac55b0b9d1f7a0697bdc1de8a0e6c0f35">getID</a>() const override final {</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keywordflow">return</span> m_collectionID;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;  }</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a009e82566575769c194ef6e7986a01bd">  112</a></span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#a009e82566575769c194ef6e7986a01bd">isValid</a>() const override final {</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordflow">return</span> m_isValid;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;  }</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;  <span class="comment">// support for the iterator protocol</span></div><div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a6589e53483cf4d913cbee1d80545dac6">  117</a></span>&#160;  <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html">const_iterator</a> <a class="code" href="classeic_1_1_m_c_particle_collection.html#a6589e53483cf4d913cbee1d80545dac6">begin</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html">const_iterator</a>(0, &amp;m_entries);</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;  }</div><div class="line"><a name="l00120"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#afd29c1e40bb5aa96e2570ff69e8e1079">  120</a></span>&#160;  <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html">const_iterator</a> <a class="code" href="classeic_1_1_m_c_particle_collection.html#afd29c1e40bb5aa96e2570ff69e8e1079">end</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html">const_iterator</a>(m_entries.size(), &amp;m_entries);</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;  }</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a8344a3352ae7f2c684fd645170203ed3">  125</a></span>&#160;  <span class="keywordtype">void</span>* <a class="code" href="classeic_1_1_m_c_particle_collection.html#a8344a3352ae7f2c684fd645170203ed3">getBufferAddress</a>() override final { <span class="keywordflow">return</span> (<span class="keywordtype">void</span>*)&amp;m_data; }</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#aee84cd394f49762e3e2cfec1fbb3f0ab">  128</a></span>&#160;  std::vector&lt;MCParticleData&gt;* <a class="code" href="classeic_1_1_m_c_particle_collection.html#aee84cd394f49762e3e2cfec1fbb3f0ab">_getBuffer</a>() { <span class="keywordflow">return</span> m_data; }</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;  <span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;  <span class="keyword">const</span> std::array&lt;long long, arraysize&gt; pdg() <span class="keyword">const</span>;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;  <span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;  <span class="keyword">const</span> std::array&lt;long long, arraysize&gt; genstatus() <span class="keyword">const</span>;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  <span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;  <span class="keyword">const</span> std::array&lt;std::array&lt;double, 3&gt;, arraysize&gt; vertex() <span class="keyword">const</span>;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;  <span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;  <span class="keyword">const</span> std::array&lt;float, arraysize&gt; charge() <span class="keyword">const</span>;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;  <span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;  <span class="keyword">const</span> std::array&lt;float, arraysize&gt; mass() <span class="keyword">const</span>;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;  <span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;  <span class="keyword">const</span> std::array&lt;float, arraysize&gt; time() <span class="keyword">const</span>;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;  <span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;  <span class="keyword">const</span> std::array&lt;std::array&lt;double, 3&gt;, arraysize&gt; endpoint() <span class="keyword">const</span>;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;  <span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;  <span class="keyword">const</span> std::array&lt;bool, arraysize&gt; endpointSet() <span class="keyword">const</span>;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;  <span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;  <span class="keyword">const</span> std::array&lt;std::array&lt;double, 3&gt;, arraysize&gt; momentum() <span class="keyword">const</span>;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;  <span class="keywordtype">bool</span> m_isValid;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;  <span class="keywordtype">int</span> m_collectionID;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;  <a class="code" href="namespaceeic.html#a3b60abb8ab87a16a3de493b946494cd8">MCParticleObjPointerContainer</a> m_entries;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;  <span class="comment">// members to handle 1-to-N-relations</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;  std::vector&lt;eic::ConstMCParticle&gt;* m_rel_parents; </div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;  std::vector&lt;std::vector&lt;eic::ConstMCParticle&gt;*&gt; m_rel_parents_tmp; </div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;  std::vector&lt;eic::ConstMCParticle&gt;* m_rel_daughters; </div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;  std::vector&lt;std::vector&lt;eic::ConstMCParticle&gt;*&gt; m_rel_daughters_tmp; </div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;  <span class="comment">// members to handle vector members</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;  <span class="comment">// members to handle streaming</span></div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;  podio::CollRefCollection m_refCollections;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;  podio::VectorMembersInfo m_vecmem_info;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;  <a class="code" href="namespaceeic.html#a5bd8e90bfeab64c62afd20fef747150d">MCParticleDataContainer</a>* m_data;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;};</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;std::ostream&amp; <a class="code" href="namespaceeic.html#a207cb16b7a2df08e82d05c73c144487f">operator&lt;&lt;</a>(std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html">MCParticleCollection</a>&amp; v);</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00170"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a2c5d9fecc1a8ef0b89715726564c3a11">  170</a></span>&#160;<a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> <a class="code" href="classeic_1_1_m_c_particle_collection.html#ab6428411972f6aeeeee160650ebbe15d">MCParticleCollection::create</a>(Args&amp;&amp;... args) {</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;  <span class="keyword">const</span> <span class="keywordtype">int</span> size = m_entries.size();</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;  <span class="keyword">auto</span> obj = <span class="keyword">new</span> <a class="code" href="classeic_1_1_m_c_particle_obj.html">MCParticleObj</a>({size, m_collectionID}, {args...});</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;  m_entries.push_back(obj);</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a>(obj);</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;}</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00178"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a90e403a5b70fb3830d8a7aea4709ff3d">  178</a></span>&#160;<span class="keyword">const</span> std::array&lt;long long, arraysize&gt; <a class="code" href="classeic_1_1_m_c_particle_collection.html#a90e403a5b70fb3830d8a7aea4709ff3d">MCParticleCollection::pdg</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;  std::array&lt;long long, arraysize&gt; tmp;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> valid_size = std::min(arraysize, m_entries.size());</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; valid_size; ++i) {</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    tmp[i] = m_entries[i]-&gt;data.pdg;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;  }</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;  <span class="keywordflow">return</span> tmp;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;}</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;<span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00188"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#abd8a939f84ae2dddefcc85f14c29fdef">  188</a></span>&#160;<span class="keyword">const</span> std::array&lt;long long, arraysize&gt; <a class="code" href="classeic_1_1_m_c_particle_collection.html#abd8a939f84ae2dddefcc85f14c29fdef">MCParticleCollection::genstatus</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;  std::array&lt;long long, arraysize&gt; tmp;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> valid_size = std::min(arraysize, m_entries.size());</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; valid_size; ++i) {</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    tmp[i] = m_entries[i]-&gt;data.genstatus;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;  }</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;  <span class="keywordflow">return</span> tmp;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;}</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00198"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#aea407b6168f58f843f2d469a846f7406">  198</a></span>&#160;<span class="keyword">const</span> std::array&lt;std::array&lt;double, 3&gt;, arraysize&gt; <a class="code" href="classeic_1_1_m_c_particle_collection.html#aea407b6168f58f843f2d469a846f7406">MCParticleCollection::vertex</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;  std::array&lt;std::array&lt;double, 3&gt;, arraysize&gt; tmp;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> valid_size = std::min(arraysize, m_entries.size());</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; valid_size; ++i) {</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    tmp[i] = m_entries[i]-&gt;data.vertex;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;  }</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;  <span class="keywordflow">return</span> tmp;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;}</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;<span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00208"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#ae2446dc823db49fa808d753766a2199e">  208</a></span>&#160;<span class="keyword">const</span> std::array&lt;float, arraysize&gt; <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae2446dc823db49fa808d753766a2199e">MCParticleCollection::charge</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;  std::array&lt;float, arraysize&gt; tmp;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> valid_size = std::min(arraysize, m_entries.size());</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; valid_size; ++i) {</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    tmp[i] = m_entries[i]-&gt;data.charge;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;  }</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;  <span class="keywordflow">return</span> tmp;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;}</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;<span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00218"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#adf4952a746cf61e5cd3ec67846cdf85e">  218</a></span>&#160;<span class="keyword">const</span> std::array&lt;float, arraysize&gt; <a class="code" href="classeic_1_1_m_c_particle_collection.html#adf4952a746cf61e5cd3ec67846cdf85e">MCParticleCollection::mass</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;  std::array&lt;float, arraysize&gt; tmp;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> valid_size = std::min(arraysize, m_entries.size());</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; valid_size; ++i) {</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    tmp[i] = m_entries[i]-&gt;data.mass;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;  }</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;  <span class="keywordflow">return</span> tmp;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;}</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00228"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#ad96bb16d20528007e19b51b8714d7875">  228</a></span>&#160;<span class="keyword">const</span> std::array&lt;float, arraysize&gt; <a class="code" href="classeic_1_1_m_c_particle_collection.html#ad96bb16d20528007e19b51b8714d7875">MCParticleCollection::time</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;  std::array&lt;float, arraysize&gt; tmp;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> valid_size = std::min(arraysize, m_entries.size());</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; valid_size; ++i) {</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    tmp[i] = m_entries[i]-&gt;data.time;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;  }</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;  <span class="keywordflow">return</span> tmp;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;}</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;<span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00238"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a8045de2d71288f02917dc2a9da60bcd4">  238</a></span>&#160;<span class="keyword">const</span> std::array&lt;std::array&lt;double, 3&gt;, arraysize&gt; <a class="code" href="classeic_1_1_m_c_particle_collection.html#a8045de2d71288f02917dc2a9da60bcd4">MCParticleCollection::endpoint</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;  std::array&lt;std::array&lt;double, 3&gt;, arraysize&gt; tmp;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> valid_size = std::min(arraysize, m_entries.size());</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; valid_size; ++i) {</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    tmp[i] = m_entries[i]-&gt;data.endpoint;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;  }</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;  <span class="keywordflow">return</span> tmp;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;}</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00248"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a1f6d48898d33f82ea76c6112b913605d">  248</a></span>&#160;<span class="keyword">const</span> std::array&lt;bool, arraysize&gt; <a class="code" href="classeic_1_1_m_c_particle_collection.html#a1f6d48898d33f82ea76c6112b913605d">MCParticleCollection::endpointSet</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;  std::array&lt;bool, arraysize&gt; tmp;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> valid_size = std::min(arraysize, m_entries.size());</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; valid_size; ++i) {</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    tmp[i] = m_entries[i]-&gt;data.endpointSet;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;  }</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;  <span class="keywordflow">return</span> tmp;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;}</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;<span class="keyword">template</span>&lt;<span class="keywordtype">size_t</span> arraysize&gt;</div><div class="line"><a name="l00258"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#afe6f1bba9edbe0b08846709feb5da6fc">  258</a></span>&#160;<span class="keyword">const</span> std::array&lt;std::array&lt;double, 3&gt;, arraysize&gt; <a class="code" href="classeic_1_1_m_c_particle_collection.html#afe6f1bba9edbe0b08846709feb5da6fc">MCParticleCollection::momentum</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;  std::array&lt;std::array&lt;double, 3&gt;, arraysize&gt; tmp;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> valid_size = std::min(arraysize, m_entries.size());</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; valid_size; ++i) {</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    tmp[i] = m_entries[i]-&gt;data.momentum;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;  }</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;  <span class="keywordflow">return</span> tmp;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;}</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;} <span class="comment">// namespace eic</span></div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classeic_1_1_m_c_particle_html"><div class="ttname"><a href="classeic_1_1_m_c_particle.html">eic::MCParticle</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_8h_source.html#l00028">MCParticle.h:28</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a90e403a5b70fb3830d8a7aea4709ff3d"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a90e403a5b70fb3830d8a7aea4709ff3d">eic::MCParticleCollection::pdg</a></div><div class="ttdeci">const std::array&lt; long long, arraysize &gt; pdg() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00178">MCParticleCollection.h:178</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html_a58727d055ea313cbc311aa13cbca828b"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html#a58727d055ea313cbc311aa13cbca828b">eic::MCParticleCollectionIterator::MCParticleCollectionIterator</a></div><div class="ttdeci">MCParticleCollectionIterator(int index, const MCParticleObjPointerContainer *collection)</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00031">MCParticleCollection.h:31</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a8045de2d71288f02917dc2a9da60bcd4"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a8045de2d71288f02917dc2a9da60bcd4">eic::MCParticleCollection::endpoint</a></div><div class="ttdeci">const std::array&lt; std::array&lt; double, 3 &gt;, arraysize &gt; endpoint() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00238">MCParticleCollection.h:238</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ac55b0b9d1f7a0697bdc1de8a0e6c0f35"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ac55b0b9d1f7a0697bdc1de8a0e6c0f35">eic::MCParticleCollection::getID</a></div><div class="ttdeci">unsigned getID() const override final</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00108">MCParticleCollection.h:108</a></div></div>
<div class="ttc" id="namespaceeic_html_a5bd8e90bfeab64c62afd20fef747150d"><div class="ttname"><a href="namespaceeic.html#a5bd8e90bfeab64c62afd20fef747150d">eic::MCParticleDataContainer</a></div><div class="ttdeci">std::vector&lt; MCParticleData &gt; MCParticleDataContainer</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00026">MCParticleCollection.h:26</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_obj_html"><div class="ttname"><a href="classeic_1_1_m_c_particle_obj.html">eic::MCParticleObj</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_obj_8h_source.html#l00020">MCParticleObj.h:20</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ab6428411972f6aeeeee160650ebbe15d"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ab6428411972f6aeeeee160650ebbe15d">eic::MCParticleCollection::create</a></div><div class="ttdeci">MCParticle create()</div><div class="ttdoc">Append a new object to the collection, and return this object. </div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00051">MCParticleCollection.cc:51</a></div></div>
<div class="ttc" id="classeic_1_1_const_m_c_particle_html"><div class="ttname"><a href="classeic_1_1_const_m_c_particle.html">eic::ConstMCParticle</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_const_8h_source.html#l00026">MCParticleConst.h:26</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ad96bb16d20528007e19b51b8714d7875"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ad96bb16d20528007e19b51b8714d7875">eic::MCParticleCollection::time</a></div><div class="ttdeci">const std::array&lt; float, arraysize &gt; time() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00228">MCParticleCollection.h:228</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a009e82566575769c194ef6e7986a01bd"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a009e82566575769c194ef6e7986a01bd">eic::MCParticleCollection::isValid</a></div><div class="ttdeci">bool isValid() const override final</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00112">MCParticleCollection.h:112</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_adf4952a746cf61e5cd3ec67846cdf85e"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#adf4952a746cf61e5cd3ec67846cdf85e">eic::MCParticleCollection::mass</a></div><div class="ttdeci">const std::array&lt; float, arraysize &gt; mass() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00218">MCParticleCollection.h:218</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_af7ed58e80878af7e156475631220748b"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#af7ed58e80878af7e156475631220748b">eic::MCParticleCollection::setID</a></div><div class="ttdeci">void setID(unsigned ID) override final</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00101">MCParticleCollection.h:101</a></div></div>
<div class="ttc" id="namespaceeic_html_a207cb16b7a2df08e82d05c73c144487f"><div class="ttname"><a href="namespaceeic.html#a207cb16b7a2df08e82d05c73c144487f">eic::operator&lt;&lt;</a></div><div class="ttdeci">std::ostream &amp; operator&lt;&lt;(std::ostream &amp;o, const ConstCalorimeterHit &amp;value)</div><div class="ttdef"><b>Definition:</b> <a href="_calorimeter_hit_8cc_source.html#l00112">CalorimeterHit.cc:112</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a01fb59231ec11d4832bf89c1b7fa0244"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a01fb59231ec11d4832bf89c1b7fa0244">eic::MCParticleCollection::referenceCollections</a></div><div class="ttdeci">podio::CollRefCollection * referenceCollections() override final</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00097">MCParticleCollection.h:97</a></div></div>
<div class="ttc" id="_m_c_particle_obj_8h_html"><div class="ttname"><a href="_m_c_particle_obj_8h.html">MCParticleObj.h</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html_a18cfe3aa4eff0cc87907c9c6143770c9"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html#a18cfe3aa4eff0cc87907c9c6143770c9">eic::MCParticleCollectionIterator::operator*</a></div><div class="ttdeci">const MCParticle operator*() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00186">MCParticleCollection.cc:186</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html">eic::MCParticleCollectionIterator</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00029">MCParticleCollection.h:29</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a83bdd7d2e8c22831ecf5352434fe01cc"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a83bdd7d2e8c22831ecf5352434fe01cc">eic::MCParticleCollection::getValueTypeName</a></div><div class="ttdeci">std::string getValueTypeName() const override</div><div class="ttdoc">fully qualified type name of elements - with namespace </div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00077">MCParticleCollection.h:77</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a1f6d48898d33f82ea76c6112b913605d"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a1f6d48898d33f82ea76c6112b913605d">eic::MCParticleCollection::endpointSet</a></div><div class="ttdeci">const std::array&lt; bool, arraysize &gt; endpointSet() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00248">MCParticleCollection.h:248</a></div></div>
<div class="ttc" id="_m_c_particle_data_8h_html"><div class="ttname"><a href="_m_c_particle_data_8h.html">MCParticleData.h</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a6589e53483cf4d913cbee1d80545dac6"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a6589e53483cf4d913cbee1d80545dac6">eic::MCParticleCollection::begin</a></div><div class="ttdeci">const const_iterator begin() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00117">MCParticleCollection.h:117</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html">eic::MCParticleCollection</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00050">MCParticleCollection.h:50</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_afd29c1e40bb5aa96e2570ff69e8e1079"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#afd29c1e40bb5aa96e2570ff69e8e1079">eic::MCParticleCollection::end</a></div><div class="ttdeci">const const_iterator end() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00120">MCParticleCollection.h:120</a></div></div>
<div class="ttc" id="namespaceeic_html_a3b60abb8ab87a16a3de493b946494cd8"><div class="ttname"><a href="namespaceeic.html#a3b60abb8ab87a16a3de493b946494cd8">eic::MCParticleObjPointerContainer</a></div><div class="ttdeci">std::deque&lt; MCParticleObj * &gt; MCParticleObjPointerContainer</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00027">MCParticleCollection.h:27</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html_a208df947157c71dfcd9700c6cd244d2b"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html#a208df947157c71dfcd9700c6cd244d2b">eic::MCParticleCollectionIterator::operator!=</a></div><div class="ttdeci">bool operator!=(const MCParticleCollectionIterator &amp;x) const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00033">MCParticleCollection.h:33</a></div></div>
<div class="ttc" id="_m_c_particle_8h_html"><div class="ttname"><a href="_m_c_particle_8h.html">MCParticle.h</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html_af6248ebaba9075fcf9752608c95a9bff"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html#af6248ebaba9075fcf9752608c95a9bff">eic::MCParticleCollectionIterator::operator-&gt;</a></div><div class="ttdeci">const MCParticle * operator-&gt;() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00191">MCParticleCollection.cc:191</a></div></div>
<div class="ttc" id="namespaceeic_html"><div class="ttname"><a href="namespaceeic.html">eic</a></div><div class="ttdef"><b>Definition:</b> <a href="_calorimeter_hit_8cc_source.html#l00014">CalorimeterHit.cc:14</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_afe6f1bba9edbe0b08846709feb5da6fc"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#afe6f1bba9edbe0b08846709feb5da6fc">eic::MCParticleCollection::momentum</a></div><div class="ttdeci">const std::array&lt; std::array&lt; double, 3 &gt;, arraysize &gt; momentum() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00258">MCParticleCollection.h:258</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a04a4b9fb0e399346bf332f113db46235"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a04a4b9fb0e399346bf332f113db46235">eic::MCParticleCollection::vectorMembers</a></div><div class="ttdeci">podio::VectorMembersInfo * vectorMembers() override</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00099">MCParticleCollection.h:99</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html_a135e791096be03f92c8ae6caaea014e5"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html#a135e791096be03f92c8ae6caaea014e5">eic::MCParticleCollectionIterator::operator++</a></div><div class="ttdeci">const MCParticleCollectionIterator &amp; operator++() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00196">MCParticleCollection.cc:196</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a8344a3352ae7f2c684fd645170203ed3"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a8344a3352ae7f2c684fd645170203ed3">eic::MCParticleCollection::getBufferAddress</a></div><div class="ttdeci">void * getBufferAddress() override final</div><div class="ttdoc">returns the address of the pointer to the data buffer </div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00125">MCParticleCollection.h:125</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ae2446dc823db49fa808d753766a2199e"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ae2446dc823db49fa808d753766a2199e">eic::MCParticleCollection::charge</a></div><div class="ttdeci">const std::array&lt; float, arraysize &gt; charge() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00208">MCParticleCollection.h:208</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_aee84cd394f49762e3e2cfec1fbb3f0ab"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#aee84cd394f49762e3e2cfec1fbb3f0ab">eic::MCParticleCollection::_getBuffer</a></div><div class="ttdeci">std::vector&lt; MCParticleData &gt; * _getBuffer()</div><div class="ttdoc">Returns the pointer to the data buffer. </div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00128">MCParticleCollection.h:128</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_aea407b6168f58f843f2d469a846f7406"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#aea407b6168f58f843f2d469a846f7406">eic::MCParticleCollection::vertex</a></div><div class="ttdeci">const std::array&lt; std::array&lt; double, 3 &gt;, arraysize &gt; vertex() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00198">MCParticleCollection.h:198</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_abd8a939f84ae2dddefcc85f14c29fdef"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#abd8a939f84ae2dddefcc85f14c29fdef">eic::MCParticleCollection::genstatus</a></div><div class="ttdeci">const std::array&lt; long long, arraysize &gt; genstatus() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00188">MCParticleCollection.h:188</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
